Bug 1198498 - Review Request: libwebsockets - A lightweight C library for Websockets
Summary: Review Request: libwebsockets - A lightweight C library for Websockets
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Rich Mattes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1197678
TreeView+ depends on / blocked
 
Reported: 2015-03-04 09:43 UTC by Fabian Affolter
Modified: 2016-07-13 14:34 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-07-13 14:34:51 UTC
Type: ---
richmattes: fedora-review+


Attachments (Terms of Use)
New source rpm (2.74 MB, application/x-rpm)
2016-01-21 02:07 UTC, Andrew Cooks
no flags Details
Source RPM for libwebsockets-1.6.1 (2.74 MB, application/x-rpm)
2016-01-21 23:58 UTC, Andrew Cooks
no flags Details

Description Fabian Affolter 2015-03-04 09:43:10 UTC
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/libwebsockets.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/libwebsockets-1.3-1.fc21.src.rpm

Project URL: http://libwebsockets.org

Description:
This is the libwebsockets C library for lightweight websocket clients and
servers.

Koji scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=9135860

rpmlint output:
[fab@laptop017 SRPMS]$ rpmlint libwebsockets-1.3-1.fc21.src.rpm 
libwebsockets.src: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket
libwebsockets.src:54: E: hardcoded-library-path in %{buildroot}/usr/lib/cmake/libwebsockets/*.cmake
1 packages and 0 specfiles checked; 1 errors, 1 warnings.

[fab@laptop017 x86_64]$ rpmlint libwebsockets-*
libwebsockets.x86_64: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket
libwebsockets.x86_64: W: pem-certificate /usr/share/libwebsockets-test-server/libwebsockets-test-server.pem
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-ping
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server-extpoll
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-echo
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-fraggle
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-client
libwebsockets-devel.x86_64: W: only-non-binary-in-usr-lib
3 packages and 0 specfiles checked; 0 errors, 9 warnings.

Fedora Account System Username: fab

Comment 1 Rich Mattes 2015-03-04 15:56:00 UTC
I'll take this review.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: libs/sha-1.c is BSD
     Note: lib/base64-decode.c and lib/ssl-http2.c are MIT
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
     Note: libs/sha-1.c should be noted as bundled, as per
     https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#Requirement_if_you_bundle
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
     Note: Is there any reason to delete the CMake modules being installed?
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[-]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libwebsockets-1.3-1.fc21.x86_64.rpm
          libwebsockets-devel-1.3-1.fc21.x86_64.rpm
          libwebsockets-1.3-1.fc21.src.rpm
libwebsockets.x86_64: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket
libwebsockets.x86_64: W: pem-certificate /usr/share/libwebsockets-test-server/libwebsockets-test-server.pem
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-ping
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server-extpoll
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-echo
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-fraggle
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-client
libwebsockets-devel.x86_64: W: only-non-binary-in-usr-lib
libwebsockets.src: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket
libwebsockets.src:54: E: hardcoded-library-path in %{buildroot}/usr/lib/cmake/libwebsockets/*.cmake
3 packages and 0 specfiles checked; 1 errors, 10 warnings.




Requires
--------
libwebsockets (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    libssl.so.10()(64bit)
    libssl.so.10(libssl.so.10)(64bit)
    libwebsockets.so.4.0.0()(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

libwebsockets-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libwebsockets(x86-64)
    libwebsockets.so.4.0.0()(64bit)



Provides
--------
libwebsockets:
    libwebsockets
    libwebsockets(x86-64)
    libwebsockets.so.4.0.0()(64bit)

libwebsockets-devel:
    libwebsockets-devel
    libwebsockets-devel(x86-64)
    pkgconfig(libwebsockets)



Source checksums
----------------
http://git.libwebsockets.org/cgi-bin/cgit/libwebsockets/snapshot/libwebsockets-1.3-chrome37-firefox30.tar.gz :
  CHECKSUM(SHA256) this package     : 022c91f821014c50b9db5fb93404df475dc081a7c23b57fca9529e3ddcc5d821
  CHECKSUM(SHA256) upstream package : 022c91f821014c50b9db5fb93404df475dc081a7c23b57fca9529e3ddcc5d821


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -b 1198498
Buildroot used: fedora-21-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


===============================================

So the issues are:
- Sort out licensing and bundled libs requirements for sha-1.c, base64-decode.c, and ssl-http2.c
- Use the %license macro for license files: https://fedoraproject.org/wiki/Packaging:LicensingGuidelines
- Consider fixing the CMake script installation location putting them in the -devel package

Comment 2 Fabian Affolter 2015-03-10 18:14:20 UTC
Upstream bug for the bundled libs: https://github.com/warmcat/libwebsockets/issues/252

Comment 3 Andy Green 2015-03-11 00:01:03 UTC
Hi I am the library author.

First thanks for taking the time to go through the packaging process for lws.  I use Fedora since it started and lws is written on a Fedora box.  So I will try to resolve these problems.

1) sha-1.c has the following lgpl2 compatible notice

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

We previously used openssl sha-1, but lws is ported to many platforms and alsa cyassl, so it has its own.  We can add an option to force use of openssl one.

2) base64-decode has the following lgpl2 compatible notice

 * This code originally came from here
 *
 * http://base64.sourceforge.net/b64.c
 *
 * with the following license:
 *
 * LICENCE:        Copyright (c) 2001 Bob Trower, Trantor Standard Systems Inc.
 *
 *                Permission is hereby granted, free of charge, to any person
 *                obtaining a copy of this software and associated
 *                documentation files (the "Software"), to deal in the
 *                Software without restriction, including without limitation
 *                the rights to use, copy, modify, merge, publish, distribute,
 *                sublicense, and/or sell copies of the Software, and to
 *                permit persons to whom the Software is furnished to do so,
 *                subject to the following conditions:
 *
 *                The above copyright notice and this permission notice shall
 *                be included in all copies or substantial portions of the
 *                Software.
 *
 *                THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
 *                KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 *                WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 *                PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
 *                OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 *                OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 *                OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *                SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

The total code excluding the selftest is ~120 LOC, it's cleaned and optimized compared to the original.  However if Fedora wants to use an external library for it, I can add it as an option if you let me know which one.

3) The code taken from nghttp2 is a trivial amount around correct openssl apis for using alpn, not exported standalone from the original lib.  ssl-http2 has this notice with lgpl-compatible terms

 * Some or all of this file is based on code from nghttp2, which has the
 * following license.  Since it's more liberal than lws license, you're also
 * at liberty to get the original code from
 * https://github.com/tatsuhiro-t/nghttp2 under his liberal terms alone.
 * 
 * nghttp2 - HTTP/2.0 C Library
 *
 * Copyright (c) 2012 Tatsuhiro Tsujikawa
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Comment 4 Rich Mattes 2015-03-11 12:49:16 UTC
The bundled library guidelines are mostly about trying to minimize the amount of duplicate code in the distribution for bugfix and security reasons (its easier to update a flaw in a single shared library than it is in 30 copies of sha1.c scattered around the distribution).  For small copylibs like this, an alternative exists where the package needs to add metadata that indicates the copylib's presence, for tracking purposes.

The sha-1.c file already has a standing exception to the bundled library policy, and can be used as-is as long as the proper Provides: are in place as described in the table at https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries#Requirement_if_you_bundle.  No action is needed upstream.

b64.c looks like it's in the same boat, and would probably be approved as a copylib by the fpc.  But if it's sufficiently modified from the original implementation, it would probably be considered a fork and OK to include as-is.

The nghttp2 code would probably also be considered a fork since you're just copying a small private API from another project.

So I would file a ticket with the FPC asking them to look at both of these libs and verify that their use is OK before doing any work to port away from them upstream.  I'm reasonably confident that they are, but I'd like to get the official ack.

Comment 5 Daniel O'Connor 2015-06-23 06:12:08 UTC
Hi; for those of us not super familiar - FPC = Fedora Packaging Comittee (https://fedoraproject.org/wiki/Packaging_Committee?rd=Packaging:Committee)? And all we need to do is log a trac ticket, and attend a meeting or at least ensure it's on the agenda?)

If so, I've raised https://fedorahosted.org/fpc/ticket/546 ; which I hope is enough detail but please feel free to expand on it.

Comment 6 Daniel O'Connor 2015-06-26 09:26:47 UTC
From the trac ticket:

Status changed from meeting to closed
Resolution set to accepted

We discussed this at this weeks meeting (​http://meetbot.fedoraproject.org/fedora-meeting-1/2015-06-25/fpc.2015-06-25-16.01.txt):

Comment 7 Jason Tibbitts 2015-06-26 17:02:46 UTC
That's oversimplifying a bit.

The actual ticket says:

ACTION: Bundling of base64/random SSL setup bits. (+1:5, 0:1, -1:0) (geppetto, 17:19:48)

ACTION: Bundling of "custom" sha1 implementation. (+1:3, 0:1, -1:2) … just link to the openssl functions, as you have build options for it. (geppetto, 17:20:04) 

https://fedorahosted.org/fpc/ticket/546#comment:2

Comment 8 Rich Mattes 2015-06-28 17:23:10 UTC
So to clarify, the base64 and nghttp2 ssl bits are forks/OK to bundle, and the sha1 implementation should defer to the OpenSSL implementation?

Comment 9 Andrew Elwell 2015-09-04 17:10:50 UTC
Hi - I'm trying to move this forwards now that 1.4 is out (I've got a new spec and srpm) - however the blocker is the FPC request to use the openssl functions for sha1.

I tried to create a trac ticket on libwebsockets.org to request this, but trac threw an internal server error. Hoping you'll (Andy) spot this as you're still subscribed to  this bug.

I can't see a specific version so is
Provides: bundled(base64-decode)
Provides: bundled(ssl-http2)
enough?

Comment 10 Rich Mattes 2015-09-05 15:45:16 UTC
I think those provides are fine.  I'll continue with the review once the new SRPM is posted.

Comment 11 Roger Light 2015-09-29 12:28:43 UTC
Andrew - I know that Andy is happy to accept bug reports on the github issues page: https://github.com/warmcat/libwebsockets/issues

There hasn't been a lot of libwebsockets activity recently though, mostly Andy has just posted to say that he is buried in work.

Comment 12 Andy Green 2015-12-27 01:21:44 UTC
The ability to select at CMake time whether to use inbuilt SHA1 or openssl SHA1 was solved and pushed on 2015-10-15.

https://github.com/warmcat/libwebsockets/commit/4c79ee7598aa6c13716d0b0e27838c97495b1809

The last couple of months I caught up on the backlog and appointed a comaintainer, and we made several releases.

Comment 13 Andrew Cooks 2016-01-21 02:07:27 UTC
Created attachment 1116761 [details]
New source rpm

With the attached src rpm I've tried to address the bundling/licensing issues listed in this bug report. 'fedora-review' lists a number of new items for manual review, but I've done as much as my experience allows.

A copr build is available at
https://copr.fedoraproject.org/coprs/acooks/libwebsockets/

Comment 14 Andrew Cooks 2016-01-21 23:58:58 UTC
Created attachment 1117035 [details]
Source RPM for libwebsockets-1.6.1

Here's an updated src rpm for a new release with important bug fixes.

Upstream announcement:
http://ml.libwebsockets.org/pipermail/libwebsockets/2016-January/002165.html

Is there anything else I can do to help this package ship?

Comment 15 Upstream Release Monitoring 2016-01-24 11:23:25 UTC
fab's scratch build of libwebsockets-1.6.1-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12667680

Comment 16 Fabian Affolter 2016-01-24 12:02:13 UTC
%changelog
* Sun Jan 24 2016 Fabian Affolter <mail@fabian-affolter.ch> - 1.6.1-2
- Update to latest upstream release 1.6.1

* Fri Jan 22 2016 Fabian Affolter <mail@fabian-affolter.ch> - 1.5.1-2
- Update spec file
- Update to latest upstream release 1.5.1

Updated files: 
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/libwebsockets.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/libwebsockets-1.6.1-1.fc23.src.rpm

Comment 17 Upstream Release Monitoring 2016-01-24 23:15:44 UTC
acooks's scratch build of libwebsockets-1.6.1-2.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12671396

Comment 18 Andrew Cooks 2016-01-24 23:22:55 UTC
(In reply to Upstream Release Monitoring from comment #17)
> acooks's scratch build of libwebsockets-1.6.1-2.fc23.src.rpm for rawhide
> completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12671396

Um, sorry about the noise. I was just trying out koji to understand what Fabian was doing, and why. I didn't know that it would automagically find this bug and modify it.

Comment 19 Zbigniew Jędrzejewski-Szmek 2016-01-30 16:03:17 UTC
libwebsockets came up as an optional dependency of qlcplus (#1297821).
It would be nice to get this package into Fedora.

Comment 20 Rich Mattes 2016-02-05 13:22:59 UTC
Thanks for tagging me, I missed the latest spec/srpm update.  I will try to finish the review this weekend.

Comment 21 Rich Mattes 2016-02-07 17:21:57 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     NOTE: According to the source files, the license is LGPLv2; there's no
     "or any later version" statement in the copyright headers.
     NOTE: License strings in the License: field must have "and" between them,
     so it should read "LGPLv2 and BSD and MIT and zlib"
     There should also be comments as to which license applies to which pieces - 
     the main library is LGPL, and the some of the bundled deps are not.
     https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#Multiple_Licensing_Scenarios
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 174080 bytes in 6 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 2734080 bytes in /usr/share
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: libwebsockets-1.6.1-1.fc23.x86_64.rpm
          libwebsockets-devel-1.6.1-1.fc23.x86_64.rpm
          libwebsockets-debuginfo-1.6.1-1.fc23.x86_64.rpm
          libwebsockets-1.6.1-1.fc23.src.rpm
libwebsockets.x86_64: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket
libwebsockets.x86_64: W: incoherent-version-in-changelog 1.6.1-2 ['1.6.1-1.fc23', '1.6.1-1']
libwebsockets.x86_64: W: invalid-license LGPLv2+ BSD MIT zlib
libwebsockets.x86_64: W: crypto-policy-non-compliance-openssl /usr/lib64/libwebsockets.so.6 SSL_CTX_set_cipher_list
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-client
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-ping
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server-extpoll
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server-pthreads
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-fraggle
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-echo
libwebsockets-devel.x86_64: W: invalid-license LGPLv2+ BSD MIT zlib
libwebsockets-devel.x86_64: W: only-non-binary-in-usr-lib
libwebsockets-debuginfo.x86_64: W: invalid-license LGPLv2+ BSD MIT zlib
libwebsockets.src: W: spelling-error %description -l en_US websocket -> web socket, web-socket, socket
libwebsockets.src: W: invalid-license LGPLv2+ BSD MIT zlib
libwebsockets.src:18: W: unversioned-explicit-provides bundled(sha1-hollerbach)
libwebsockets.src:19: W: unversioned-explicit-provides bundled(base64-decode)
libwebsockets.src:20: W: unversioned-explicit-provides bundled(ssl-http2)
libwebsockets.src:37: W: macro-in-comment %patch0
libwebsockets.src:19: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 19)
4 packages and 0 specfiles checked; 0 errors, 21 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libwebsockets-debuginfo-1.6.1-1.fc23.x86_64.rpm
libwebsockets-debuginfo.x86_64: W: invalid-license LGPLv2+ BSD MIT zlib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
libwebsockets.x86_64: W: incoherent-version-in-changelog 1.6.1-2 ['1.6.1-1.fc23', '1.6.1-1']
libwebsockets.x86_64: W: invalid-license LGPLv2+ BSD MIT zlib
libwebsockets.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebsockets.so.6 /lib64/libm.so.6
libwebsockets.x86_64: W: crypto-policy-non-compliance-openssl /usr/lib64/libwebsockets.so.6 SSL_CTX_set_cipher_list
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-ping
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-echo
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server-extpoll
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-fraggle
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-client
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server
libwebsockets.x86_64: W: no-manual-page-for-binary libwebsockets-test-server-pthreads
libwebsockets-debuginfo.x86_64: W: invalid-license LGPLv2+ BSD MIT zlib
libwebsockets-devel.x86_64: W: invalid-license LGPLv2+ BSD MIT zlib
libwebsockets-devel.x86_64: W: only-non-binary-in-usr-lib
3 packages and 0 specfiles checked; 0 errors, 14 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /home/rich/fedora/1198498-libwebsockets/srpm/libwebsockets.spec	2016-01-31 11:05:24.566699701 -0500
+++ /home/rich/fedora/1198498-libwebsockets/srpm-unpacked/libwebsockets.spec	2016-01-24 06:06:20.000000000 -0500
@@ -26,4 +26,5 @@
 %package devel
 Summary:        Headers for developing programs that will use %{name}
+Group:          Development/Libraries
 Requires:       %{name}%{?_isa} = %{version}-%{release}
 
@@ -76,4 +77,5 @@
 %{_libdir}/pkgconfig/%{name}.pc
 
+
 %changelog
 * Sun Jan 24 2016 Fabian Affolter <mail@fabian-affolter.ch> - 1.6.1-2


Requires
--------
libwebsockets (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libssl.so.10()(64bit)
    libssl.so.10(libssl.so.10)(64bit)
    libwebsockets.so.6()(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

libwebsockets-debuginfo (rpmlib, GLIBC filtered):

libwebsockets-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libwebsockets(x86-64)
    libwebsockets.so.6()(64bit)



Provides
--------
libwebsockets:
    bundled(base64-decode)
    bundled(sha1-hollerbach)
    bundled(ssl-http2)
    libwebsockets
    libwebsockets(x86-64)
    libwebsockets.so.6()(64bit)

libwebsockets-debuginfo:
    libwebsockets-debuginfo
    libwebsockets-debuginfo(x86-64)

libwebsockets-devel:
    libwebsockets-devel
    libwebsockets-devel(x86-64)
    pkgconfig(libwebsockets)



Source checksums
----------------
https://github.com/warmcat/libwebsockets/archive/v1.6.1.tar.gz#/libwebsockets-1.6.1.tar.gz :
  CHECKSUM(SHA256) this package     : 482ea24e8c8f50f456e93eae3a5ec8f00b2172736bd548b2a83926df957816ef
  CHECKSUM(SHA256) upstream package : 482ea24e8c8f50f456e93eae3a5ec8f00b2172736bd548b2a83926df957816ef

=====================================

Main items:
- Update the License: field to the correct format, verify version of LGPL in use, and add some more comments.

I also thought it was interesting that rpmlint flagged the openssl cipher list, based on the new-ish crypto policy:
https://fedoraproject.org/wiki/Packaging:CryptoPolicies
It looks like libwebsockets never sets the cipher list directly, it just provides an "ssl_cipher_list" string in its api for library users, and if the user doesn't explicitly provide a cipher list, the function is not called and the system default is used.

Comment 22 Andy Green 2016-02-08 01:06:33 UTC
I pushed a patch on v1.6-stable (and master)

https://github.com/warmcat/libwebsockets/commit/ebfdb0d24d9555d745d2457d0691a4ae9770624b

It lists in LICENSE the disposition of sources that had other licences.

I also took the opportunity to make the test apps public domain (cc-zero) since they are intended to be adapted by users into their own code without any 'viralness'.

+3) Some sources included have their own, more liberal licenses, or options
+to get original sources with the liberal terms.
+
+Original liberal license retained
+
+  - lib/sha-1.c         - 3-clause BSD license retained, link to original
+  - win32port/zlib      - ZLIB license (see zlib.h)
+
+Relicensed to libwebsocket license
+
+  - lib/base64-decode.c - relicensed to LGPL2.1+SLE, link to original
+  - lib/daemonize.c     - relicensed from Public Domain to LGPL2.1+SLE,
+                          link to original Public Domain version
+
+Public Domain (CC-zero) to simplify reuse
+
+  - test-server/*.c
+  - test-server/*.h

That's tagged as v1.6.3

About the ciphers, yes unless lws has some reason to do something fixed itself, things can be set at runtime by the user code with a reasonable default if not.  As you say the library doesn't enforce anything about ciphers itself but the code using it may do so if it wants.  Otherwise it just uses what the SSL library defaults to.

Comment 23 Fabian Affolter 2016-03-22 17:59:10 UTC
(In reply to Rich Mattes from comment #21)
> Main items:
> - Update the License: field to the correct format, verify version of LGPL in
> use, and add some more comments.

Format updated and some more comment

%changelog
* Tue Mar 22 2016 Fabian Affolter <mail@fabian-affolter.ch> - 1.7.4-1
- Update licenses
- Update to latest upstream release 1.7.4

Updated files: 
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/libwebsockets.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/libwebsockets-1.7.4-1.fc23.src.rpm

Comment 24 Rich Mattes 2016-03-26 23:48:01 UTC
It looks like the source files all include the following lines:

 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation:
 *  version 2.1 of the License.

Given that, the License: field of the spec should read LGPLv2 instead of LGPLv2+ (the + is for when the the "or (at your option) any later version" text is included.)

Be sure to fix that before uploading the package.  Otherwise, things look good, and this package is APPROVED.

Comment 25 Fabian Affolter 2016-04-03 13:26:05 UTC
Thanks for the review.

Comment 26 Gwyn Ciesla 2016-04-04 13:56:26 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/libwebsockets

Comment 27 Rich Mattes 2016-07-13 14:34:51 UTC
Package is imported and built, closing.


Note You need to log in before you can comment on or make changes to this bug.